//This is the logic creation
# include<iostream>
# include<stdlib.h>
# include<time.h>
using namespace std;
class cell
{	private:
            int flag;	//flag-to store the status as to whether the cell is explored or not.
            int num;	//num- to store the numerical value of the cell .
	public:
	    cell()
	    {
		flag=0;
		num=0;
	    }

            void setflag();	//setflag()-to set the flag value for a cell to 1(when explored).
            void setnum(int);	//setnum(int)-to set the numerical value of the cell to the value passed to the function.     
            int getflag();	//getflag()-to get the flag value of a cell.
            int getnum();	//getnum()-to get the numerical value of a cell.
};

cell **gameboard;	//Two global 2-dimensional arrays are defined of the type cell  .    
cell **problemboard;

void cell::setflag()
{
	flag=1;
}
void cell::setnum(int n)
{
	num=n;
}
int cell::getflag()
{
	return flag;
}
int cell::getnum()
{
	return num;
}

cell** setmines(int m,int n,int nofmines)		/*It randomly sets the mines in the gameboard.
It takes number of rows, number of columns and number of mines as input. It initializes the seed value for the srand function using time at the giving instant. It initializes intial count of mines to zero. The elements of gameboard are now initialized. While the mines inserted are less than the number of mines wanted, the following steps are repeated:
1.The remainder of any random value when divided by number of rows is calculated to get a random row index.
2.The remainder of any random value when divided by number of columns is calculated to get a random column index.
3.If a mine has not been inserted earlier at the calculated position then it is now inserted (it is created to prevent mine generation at the same position.
4.Now in all the boxes around the mines the numerical value is incremented by 1 except the boxes where there are mines.
5.The count variable signifying the number of mines inserted is incremented.
6.After the iteration ends the gameboard is returned to the calling function.*/
{

	int i,j,k,l;
	srand(time(0));
	int count=0;

        cell **gameboard=new cell*[m];
  	for(i=0;i<m;i++)
	   gameboard[i]=new cell[n];


	while(count<nofmines)
	{
		i=(rand())%m;
		j=(rand())%n;
		if(gameboard[i][j].getnum()!=-1)
		{
			gameboard[i][j].setnum(-1);
			//cout<<i<<","<<j<<" mine set"<<endl;

			for(k=i-1;k<=i+1;k++)
			{
				for(l=j-1;l<=j+1;l++)
				{
					if((k>=0 && k<m) && (l>=0 && l<n))
					{	if((k==i && l==j) || gameboard[k][l].getnum()==-1)
						{	//cout<<"i and j are equal"<<endl;
							continue;

						}
						//cout<<"Incremented "<<k<<","<<l<<"pair"<<endl;
						gameboard[k][l].setnum(gameboard[k][l].getnum()+1);
					}
				}
			}


			count++;
		}
	}
	return gameboard;
}
void openzero(int i, int j,int rowsize,int columnsize,cell** gameboard,cell** problemboard)	/*It is used to open the cells when a zero is clicked on.The location of the cell is taken as input in terms of its row and column, along with the total number of rows and columns and the two boards. A nested loop is run to encompass the 3X3 grid which include the cell being opened and the 8 surrounding cells. The following things are accomplished in the loop:-
1.It is checked whether the generated grid is within specified range. 
2.If the cell is explored the next iteration is started using continue function.
3.If the cell is not explored the concerned cell on the problemboard is set the number from the corresponding position on the gameboard.
4.If the number is zero, its flag is set to 1 and the function openzero() is called from the function itself.
5.If it is not zero, the flag is simply set to zero.*/
{
	for(int k=i-1;k<=i+1;k++)
	{
		for(int l=j-1;l<=j+1;l++)
		{
			if((k>=0 && k<rowsize) && (l>=0 && l<columnsize))
			{
				if( problemboard[k][l].getflag()==1)
				continue;
				
				problemboard[k][l].setnum(gameboard[k][l].getnum());
				
				if(gameboard[k][l].getnum()==0 )
				{
						problemboard[k][l].setflag();
						
						openzero(k,l,rowsize,columnsize,gameboard,problemboard);
				}
				else if( problemboard[k][l].getnum()!=0 )
				{
						problemboard[k][l].setflag();
			
				}

				
			}
		}
	}
}
int open(int i,int j,int m,int n,int choice,cell** gameboard,cell** problemboard)/*1 for left click and 2 for right click .It is used to open any general cell.The row and column indices of the cell to be opened, the row size, the column 	size and the two boards are passed to the function.
	a)If the choice is a left click:-
1.If the concerned cell is mine ,it returns 1 to indicate that game is over.
2.If the concerned cell is not a mine- the number and flag for the concerned cell are set.In case  the number is zero, the functionopenzero() is called. In the end 0 is returned to signify that game continues.
	b)If the choice is a right click the number is set to -1 and zero is returned.*/
{
	if(choice==1)
	{
		if(gameboard[i][j].getnum()==-1){
		  return 1;
		  }
		else
		{	
			//cout<<"i j :"<<i<<" "<<j<<endl;
			problemboard[i][j].setnum(gameboard[i][j].getnum());

			problemboard[i][j].setflag();
			if(problemboard[i][j].getnum()==0)
			{
				openzero(i,j,m,n,gameboard,problemboard);
			}
			return 0;
		}
	}
	else
	{
		problemboard[i][j].setnum(-1);
		//cout<<"Set";
		return 0;
	}
}
int compare(int row,int column,cell** gameboard,cell** problemboard)	/*It is used to compare the gameboard and problemboard at any point of time.It takes the total number 
of  rows and columns as input alongwith the two boards. The value of the flag is set as 0. It runs nested loop throughout the board to check if in any cell the problem board 
and gameboard don’t match. If they don’t match at anypoint the flag is set to 1. The flag is returned.(1-indicates that the boards don’t match while 0 indicates that the two boards 
match).*/
{
	int flag=0;
	for(int i=0;i<row;i++)
	{
		for(int j=0;j<column;j++)
		{
			if(gameboard[i][j].getnum()!=problemboard[i][j].getnum())
			flag=1;
		}
	}
	return flag;
}


